*  FILE: ADVENT02/ASM

*  <<LOOK>> SPECIAL PROCS

* LOOK CABINET

LOOK01 EQU *
 LDA #127 CABINET
 JSR CKOBJ
 LBNE DMSG16
 LDA #116 OPEN CABINET
 JSR CKOBJ
 LBEQ NOSEE
 LDA #16+INV BLANKET
 JSR MAKVIS
 BNE A@
 LDA #17+INV PILLOW
 JSR MAKVIS
 BNE A@
 LDA #8+INV SPACE SUIT
 JSR MAKVIS
 LBEQ DMSG22
A@ JSR CKDRAW
 JMP DMSG11

* LOOK POCKET

LOOK02 EQU *
 LDA #8 SPACE SUIT
 JSR LOCOBJ
 BNE A@
 LDA #9 WEARING SUIT
 JSR HAVOBJ
 LBEQ NOSEE
A@ LDA #10 LEAFLET
 JSR FNDOBJ
 LBNE DMSG22
 LDA #10 LEAFLET
 JSR PUTOBJ
 JMP DMSG11

* LOOK SCREEN

LOOK03 EQU *
 LDA ROOM
 CMPA #17 ON VELDBOER
 LBNE LOOKOB
 JMP DMSG22

* LOOK LADDER

LOOK04 EQU *
 LDA ROOM
 CMPA #6
 BEQ A@
 CMPA #15
A@ LBEQ DMSG12
 JMP LOOKOB

* LOOK DRAWER

LOOK05 EQU *
 LDA NOUNNO
 JSR CKOBJ
 BEQ B@
 LDA #27+INV CAPSULE
 JSR MAKVIS
 BNE A@
 LDA #32+INV ROPE
 JSR MAKVIS
 BEQ B@
A@ JSR CKDRAW
 JMP DMSG11
B@ JMP LOOKOB

* LOOK WHITE BUTTON

LOOK06 EQU *
 LDA #124 OPEN ACCESS PANEL
 JSR CKOBJ
 LBEQ NOSEE
 JMP DMSG12

*  <<GET>> SPECIAL PROCS

* GET SKELETON

GET01 EQU *
 LDA NOUNNO
 JSR CKOBJ
 LBEQ NOSEE
 JMP DMSG64

* GET LIQUID

GET02 EQU *
 LDA #102 POOL OF ACID
 JSR CKOBJ
 LBEQ DMSG23
 LDA #14 EMPTY BEAKER
 JSR HAVOBJ
 BEQ A@
 LDB #15 BEAKER OF ACID
 JSR REPOBJ
 JMP DMSG60
A@ LDA #24 CANTEEN
 JSR HAVOBJ
 LBEQ DMSG61
 CLRB
 JSR REPOBJ
 JMP DMSG62

* GET CARTRIDGE

GET03 EQU *
 LDA #93 ROBOT W/CART
 JSR CKOBJ
 BNE A@
 LDA #99 ROBOT W/CART
 JSR CKOBJ
 BEQ E@
A@ LDB OBJCNT
 CMPB #MAXOBJ
 LBHS DMSG9
 LDB #100
 DI
B@ JSR CHGOBJ
 TFR A,B
 LDA #26 CART
 JSR PUTNRM
 CMPB #93 DISABLED ROBOT
 BEQ D@
 LDA #163
 JSR SHOOVL
 LDY #40
 CALCX 37,17
 CALCD 37,17,72,72
C@ JSR SCRLFT
 LEAY -1,Y
 BNE C@
D@ EI
E@ JMP VGET

* GET LADDER

GET04 EQU *
 LDA ROOM
 CMPA #6
 BEQ A@
 CMPA #15
A@ LBEQ DMSG15
 JMP VGET

* GET ICE

GET05 EQU *
 LDA #96 PILE OF ICE
 JSR CKOBJ
 BNE B@
 LDA ROOM
 CMPA #8
 BLO A@
 CMPA #11
 LBLO DMSG76
A@ JMP NOSEE
B@ LDA #16 EMPTY BLANKET
 JSR HAVOBJ
 LBEQ DMSG77
 LDB #12
 JSR REPOBJ
 JMP DMSG78

* GET SPIDER

GET06 EQU *
 LDA #28
 JSR CKOBJ
 LBEQ VGET
GET06A LDX #MSG97
 JSR DISPLY
 JMP ENDGAM

* GET ROPE

GET07 EQU *
 JSR EQUOBJ
 LDA NOUNNO
 CMPA #32
 LBEQ VGET
 LDX #MSG107
 JSR DISPLY
 JMP REPLY

* GET WHITE

GET08 EQU *
 LDA #124 OPEN ACCESS PANEL
 JSR CKOBJ
 LBEQ NOSEE
 JMP DMSG15

*  <<PUT>> SPECIAL PROCS

* PUT SUIT

PUT01 EQU *
 LDA #9 WEARING SUIT
 JSR HAVOBJ
 LBNE DMSG43
 JMP VPUT

* PUT BEAKER

PUT02 EQU *
 JSR EQUOBJ
 LDA NOUNNO
 CMPA #18 BROKEN GLASS
 LBEQ VPUT
 JSR HAVOBJ
 LBEQ NOHAVE
 CLRB
 JSR REPOBJ
 LDA #17 PILLOW
 JSR CKOBJ
 BEQ A@
 LDA NOUNNO
 JSR PUTOBJ
 LDX #MSG51
 BRA B@
A@ LDA #18 BROKEN GLASS
 JSR PUTOBJ
 LDX #MSG52
B@ JSR CKDRAW
 JSR DISPLY
 JMP REPLY

* PUT BLANKET

PUT03 EQU *
 LDA #126 EMPTY BARREL
 JSR CKOBJ
 BEQ A@
 LDA #12 BLANKET W/ICE
 JSR HAVOBJ
 BEQ A@
 CLRB
 JSR REPOBJ
 LDA #126 EMPTY BARREL
 LDB #94 FULL BARREL
 JSR CHGOBJ
 JMP DMSG80
A@ JMP VPUT

*  <<GO>> SPECIAL PROCS

* GO LADDER

GO01 EQU *
 LDA ROOM
 CMPA #17
 BEQ B@
 CMPA #15
 BEQ C@
 CMPA #6
 BEQ D@
 CMPA #1
 LBNE NOSEE
 LDA #6
A@ JMP EXITRM
B@ LDA #15
 BRA A@
C@ LDA #17
 BRA A@
D@ LDA #1
 BRA A@

* GO TELEPORT WINDOW

GO02 EQU *
 LDA #120 TELEPORT WINDOW
 JSR CKOBJ
 LBEQ NOSEE
 LDA ROOM
 CMPA #3
 BNE B@
 LDA SETNX2
A@ PSHS A
 LDB #8
 DI
 LDA #54
 JSR SHOOVL
 LDA #$55
 STA FLIPSW
C@ BSR SHOBOX
 DECB
 BNE C@
 EI
 PULS A
 JMP EXITRM
B@ LDA #3
 BRA A@

* SHOW BOXES AS GO THRU WINDOW

SHOBOX EQU *
 PSHS D,X,Y
 LDA #30
 STA COLOR1
 LDA #84
 STA COLOR2
 LDX #GSCRN+65
A@ BSR DRWBOX
 LDB COLOR1
 SUBB #2
 STB COLOR1
 LDB COLOR2
 SUBB #8
 BMI C@
 STB COLOR2
 LEAX 129,X
 LDY #3000
B@ LEAY -1,Y
 BNE B@
 BRA A@
C@ LDA FLIPSW
 STA FLIPCT
 CLR FLIPSW
 LDA #30
 STA COLOR1
 LDA #84
 STA COLOR2
 LDX #GSCRN+65
D@ BSR DRWBOX
 LDB COLOR1
 SUBB #2
 STB COLOR1
 LDB COLOR2
 SUBB #8
 BMI F@
 STB COLOR2
 LEAX 129,X
 BRA D@
F@ LDA FLIPCT
 CMPA #$FF
 BNE G@
 CLRA
G@ ADDA #$55
 STA FLIPSW
 PULS D,X,Y,PC

* DRAW A BOX ON THE SCREEN
* INPUT: FLIPSW = COLOR OF BOX
*        COLOR1 = LINE LENGTH
*        COLOR2 = NO. OF LINES
*        "X" = UPPER LEFT ADDR

DRWBOX EQU *
 PSHS D,X,Y
A@ LDA FLIPSW
 LDB COLOR1
B@ STA ,X+
 DECB
 BNE B@
 LEAX 31,X
 LDB COLOR2
 LDA FLIPSW
 ANDA #3
C@ STA ,X
 LEAX 32,X
 DECB
 BNE C@
 LEAX 1,X
 LDB COLOR1
 LDA FLIPSW
D@ STA ,-X
 DECB
 BNE D@
 LEAX -32,X
 LDB COLOR2
 LDA FLIPSW
 ANDA #%11000000
E@ STA ,X
 LEAX -32,X
 DECB
 BNE E@
 PULS D,X,Y,PC

* GO HATCH

GO03 EQU *
 LDA #105 OPEN HATCH
 JSR CKOBJ
 LBEQ DMSG23
 LDA ROOM
 EORA #1
 JMP EXITRM

* GO CENOTAPH

GO04 EQU *
 LDA ROOM
 CMPA #18
 LBEQ DMSG13
 CMPA #10
 LBNE NOSEE
 LDA #18
 JMP EXITRM

* GO BRIDGE

GO05 EQU *
 JSR EQUOBJ
 LDA NOUNNO
 JSR CKOBJ
 LBEQ NOSEE
 CMPA #90 CRUMBLED BRIDGE
 LBEQ DMSG83
 LDA #33
 JMP EXITRM

* GO TREE

GO06 EQU *
 LDA NOUNNO
 JSR CKOBJ
 LBEQ NOSEE
 JMP DMSG87

* GO FORCE FIELD

GO07 EQU *
 LDA NOUNNO
 JSR CKOBJ
 LBEQ NOSEE
 LDA #25 AMULET
 JSR HAVOBJ
 LBEQ DMS110
 LDA #41
 JMP EXITRM

* GO DOORWAY

GO08 EQU *
 LDA NOUNNO
 JSR CKOBJ
 LBEQ NOSEE
 LDA ROOM
 EORA #5
 JMP EXITRM

* GO GRATE

GO09 EQU *
 JSR EQUOBJ
 LDA NOUNNO
 JSR CKOBJ
 LBEQ NOSEE
 CMPA #84
 LBEQ DMSG23
 LDA #28 SPIDER
 JSR CKOBJ
 LBNE DMSG96
 LDA ROOM
 CMPA #31
 LBEQ DMS109
 EORA #$34
 JMP EXITRM

* GO STONES/RUBBLE

GO10 EQU *
 LDA NOUNNO
 JSR CKOBJ
 LBEQ NOSEE
 LDA ROOM
 EORA #3
 JMP EXITRM

* GO ROPE

GO11 EQU *
 JSR EQUOBJ
 LDA NOUNNO
 JSR LOCOBJ
 LBEQ NOSEE
 CMPA #78
 BEQ A@
 CMPA #80
 LBNE DMSG23
A@ LDA ROOM
 CMPA #29
 LBEQ DMS109
 EORA #5
 JMP EXITRM

* GO LAVA

GO12 EQU *
 LDA #82
 JSR CKOBJ
 LBEQ NOSEE
 JMP DMSG64

* PRESS BLUE BUTTON

PRES01 EQU *
 LDA ROOM
 CMPA #3
 BNE D@
 LDA #120 TELEPORT WINDOW
 JSR CKOBJ
 BEQ A@
 CLRB
 JSR CHGOBJ
 BRA B@
A@ LDA #120 TELEPORT WINDOW
 JSR PUTNRM
B@ JSR CKDRAW
C@ JMP DMSG47
D@ CMPA #17
 BEQ C@
 CMPA #20
 BEQ C@
 CMPA #22
 BEQ C@
 CMPA #4
 BEQ E@
 CMPA #1
 LBNE NOSEE
 LDX #MSG47
 JSR DISPLY
 LDD SAVCOR
 STD MSG59A
 LDD SAVCOR+2
 STD MSG59A+2
 JMP DMSG59
E@ LDA #99 ROBOT W/CART
 JSR CKOBJ
 BEQ C@
 LDA #87 OPEN DRAWER
 JSR CKOBJ
 BNE C@
 LDA #87 OPEN DRAWER
 JSR PUTNRM
 JSR CKDRAW
 LDX #MSG47
 JSR DISPLY
 JMP DMSG11

* PRESS RED BUTTON

PRES02 EQU *
 LDA ROOM
 CMPA #34
 LBEQ F@
 CMPA #17
 LBEQ DMSG47
 CMPA #1
 LBNE NOSEE
 LDX #MSG47
 JSR DISPLY
 CLR FLIPSW
 LDB #40
A@ LDA FLIPSW
 EORA #1
 STA FLIPSW
 BEQ B@
 LDA #32 WHITE SCREEN
 BRA C@
B@ LDA #12 VIEW SCREEN
C@ DI
 JSR SHOOVL
 EI
 DECB
 BNE A@
 LDA #107 VIEW SCREEN
 STA NOUNNO
 JSR EQUOBJ
 LDA NOUNNO
 CLRB
 JSR CHGOBJ
 LDB SETNXT
 STB SETNX2
 LDA #107 VIEW SCREEN
 LDX #Z@
D@ TST ,X
 BEQ E@
 CMPB ,X++
 BNE D@
 LDA -1,X
E@ JSR PUTNRM
 JSR CKDRAW
 LDD MSG46A
 STD SAVCOR
 LDD MSG46A+2
 ANDB #$7F
 STD SAVCOR+2
 LDA #30 CHK FOR LIVE PLANT
 JSR FNDOBJ
 BEQ H@
 BMI I@
 CMPA #7
 BLO I@
H@ JMP REPLY
I@ CMPA #5
 BNE J@
 TST LITESW
 BEQ J@
 LDA #94 BARREL FULL OF WATER
 JSR FNDOBJ
 CMPA #6
 BEQ H@
J@ LDA #30 LIVE PLANT
 LDB #31 DEAD PLANT
 JSR XCHGOB
 BRA H@
Z@ FCB 11,106
 FCB 8,103
 FCB 24,92
 FCB 7,92
 FCB 0
F@ TST DOORSW
 BEQ G@
 CLR DOORSW
 JMP DMSG47
G@ INC DOORSW
 LDA #39
 JSR CLROBJ
 JMP DMSG95

* PRESS WHITE BUTTON

PRES03 EQU *
 LDA #124 OPEN ACCESS PANEL
 JSR CKOBJ
 LBEQ NOSEE
 LDA ROOM
 CMPA #6
 BNE A@
 LDA LITESW
 EORA #1
 STA LITESW
A@ JMP DMSG47

* DRINK LIQUID

DRIN01 EQU *
 LDA #15 BEAKER OF ACID
 JSR HAVOBJ
 BNE A@
 LDA #102 POOL OF ACID
 JSR CKOBJ
 LBEQ NOSEE
A@ LDX #MSG67
 JSR DISPLY
 JMP ENDGAM

* UNLOCK CABINET

UNLK01 EQU *
 LDA #11 KEY
 JSR HAVOBJ
 LBNE VOPEN
 JMP DMSG23

* UNLOCK PANEL

UNLK02 EQU *
 LDA #124 OPEN PANEL
 JSR CKOBJ
 LBNE DMSG18
 LDA #125 CLOSED PANEL
 JSR CKOBJ
 LBEQ NOSEE
 LDA #11 KEY
 JSR HAVOBJ
 LBNE DMSG74
 JMP DMSG23

* INSERT VERB PROC

VINSRT EQU *
 LDA NOUNNO
 CMPA #26 CART
 LBNE BADINP
 JSR HAVOBJ
 LBEQ NOHAVE
 LDA #100
 JSR CKOBJ
 LBEQ DMSG23
 LDB ROOM
 CMPB #22
 BNE A@
 LDB #93
 BRA B@
A@ LDB #99
B@ DI
 JSR CHGOBJ
 LDA #26 CART
 CLRB
 JSR REPOBJ
 LDA ROOM
 CMPA #22
 BEQ D@
 LDY #40
 CALCX 37,17
 CALCD 37,17,72,72
C@ JSR SCRRIT
 LEAY -1,Y
 BNE C@
 LDA #157
 JSR SHOOVL
D@ EI
 JMP REPLY

* REMOVE VERB PROC

VREMOV EQU *
 LDA NOUNNO
 CMPA #8 SUIT
 LBNE BADINP
 INCA
 JSR HAVOBJ
 LBEQ DMSG44
 LDB #8 SPACE SUIT
 JSR REPOBJ
 JMP REPLY

* REMOVE CARTRIDGE

REMO01 EQU *
 LDA #93 ROBOT WITH CART
 JSR CKOBJ
 BNE A@
 LDA #99 ROBOT WITH CART
 JSR CKOBJ
 LBEQ DMSG23
A@ JMP GET03

* DIG VERB PROC

VDIG EQU *
 LDX #MSG75
 JSR DISPLY
 JSR GETLIN
 JSR SCNKEY
 CLR NOUNNO
 LDX #NOUNTB
 LDY #NOUNNO
 LDU #VERB
 JSR SCNTBL
 JSR EQUOBJ
 LDA NOUNNO
 LBEQ BADINP
 JSR HAVOBJ
 LBEQ NOHAVE
 CMPA #23 SHOVEL
 LBNE DMSG26
 LDA ROOM
 CMPA #8
 BLO A@
 CMPA #10
 BHI A@
 LDA #96 PILE OF ICE
 JSR CKOBJ
 BNE A@
 LDA #96 PILE OF ICE
 JSR PUTNRM
 JSR CKDRAW
A@ JMP REPLY

* FEED VERB PROC

VFEED EQU *
 JSR EQUOBJ
 LDA NOUNNO
 LBEQ BADINP
 LDA #28
 JSR CKOBJ
 LBEQ DMSG23
 LDA NOUNNO
 JSR HAVOBJ
 LBEQ NOHAVE
 CLRB
 JSR REPOBJ
 CMPA #27 CAPSULE
 BNE A@
 LDA #4
 STA SPIDSW
A@ JMP DMSG98

* FEED SPIDER

FEED01 EQU *
 LDA #28
 JSR CKOBJ
 LBEQ NOSEE
 LDX #MSG99
 JSR DISPLY
 JSR GETLIN
 JSR SCNKEY
 LDX #NOUNTB
 LDY #NOUNNO
 LDU #VERB
 JSR SCNTBL
 BRA VFEED

* OPEN VERB PROC

VOPEN EQU *
 LDA NOUNNO
 CMPA #127 CABINET
 LBNE BADINP
 LDA #116 OPEN CABINET
 JSR CKOBJ
 BNE A@
 LDA #127 CLOSED CABINET
 JSR CKOBJ
 LBEQ NOSEE
 LDA #11 KEY
 JSR HAVOBJ
 LBEQ DMSG17
 LDA #127 CLOSED CABINET
 LDB #116 OPEN CABINET
 JSR CHGOBJ
 TFR B,A
 JSR CKDRAW
A@ JMP DMSG18

* OPEN MANUAL

OPEN01 EQU *
 LDA #13 OPEN MANUAL
 JSR HAVOBJ
 LBNE DMSG18
 LDA #19 CLOSED MANUAL
 JSR HAVOBJ
 LBEQ NOHAVE
 LDB #13 OPEN MANUAL
 JSR REPOBJ
 LDA #11 KEY
 JSR PUTOBJ
 JSR CKDRAW
 JMP DMSG38

* OPEN HATCH

OPEN02 EQU *
 LDA #105 OPEN HATCH
 JSR CKOBJ
 BNE A@
 LDA #104 CLOSED HATCH
 JSR CKOBJ
 LBEQ NOSEE
 LDB #105 OPEN HATCH
 JSR CHGOBJ
 JSR CKDRAW
 LDA ROOM
 CMPA #6 ON TREKBOER
 BNE A@
 LDX #MSG53
 JSR DELAY
 JMP TOTRAP
A@ JMP DMSG18

* OPEN MAP

OPEN03 EQU *
 LDA #22 OPEN MAP
 JSR HAVOBJ
 BNE A@
 LDA #21 FOLDED MAP
 JSR HAVOBJ
 LBEQ NOHAVE
 LDB #22 OPEN MAP
 JSR REPOBJ
A@ JMP DMSG18

* CLOSE HATCH

CLOS01 EQU *
 LDA #104 CLOSED HATCH
 JSR CKOBJ
 BNE A@
 LDA #105 OPEN HATCH
 JSR CKOBJ
 LBEQ NOSEE
 LDB #104 CLOSED HATCH
 JSR CHGOBJ
 JSR CKDRAW
A@ JMP DMSG16

* CLOSE MAP

CLOS02 EQU *
 LDA #21 FOLDED MAP
 JSR HAVOBJ
 BNE A@
 LDA #22 OPEN MAP
 JSR HAVOBJ
 LBEQ NOHAVE
 LDB #21 FOLDED MAP
 JSR REPOBJ
A@ JMP REPLY

* CLOSE CABINET

CLOS03 EQU *
 LDA #127 CLOSED CABINET
 JSR CKOBJ
 LBNE DMSG16
 LDA #116 OPEN CABINET
 JSR CKOBJ
 LBNE DMSG21
 JMP NOSEE

* CLOSE PANEL

CLOS04 EQU *
 LDA #125 CLOSED PANEL
 JSR CKOBJ
 LBNE DMSG16
 LDA #124 OPEN PANEL
 JSR CKOBJ
 LBNE DMSG21
 JMP NOSEE

* EAT VERB PROC

VEAT EQU *
 LDA NOUNNO
 CMPA #27 CAPSULE
 LBNE BADINP
 JSR HAVOBJ
 LBEQ NOHAVE
 LDA #9 WEARING SUIT
 JSR HAVOBJ
 LBNE DMSG94
 LDA #27 CAPSULE
 CLRB
 JSR REPOBJ
 LDA #6
 STA CAPSW
 JMP DMSG93

* TIE VERB PROC

VTIE EQU *
 LDA NOUNNO
 LBEQ BADINP
 CMPA #32 ROPE
 LBNE DMSG26
 JSR HAVOBJ
 LBEQ NOHAVE
 LDA #89 TREES
 JSR CKOBJ
 LBEQ DMSG23
 LDA #32 ROPE
 CLRB
 JSR REPOBJ
 LDA #80 ROPE TIED TO TREE
 LDB ROOM
 CMPB #27
 BEQ A@
 INCA
A@ JSR PUTNRM
 JSR CKDRAW
 LDA ROOM
 CMPA #27
 BNE B@
 PSHS A
 DI
 LDB #29
 STB ROOM
 LDA #78 DANGLING ROPE
 JSR PUTNRM
 INC ROOM
 JSR PUTNRM
 PULS A
 STA ROOM
 EI
B@ JMP DMS106

* UNTIE ROPE

VUNTIE EQU *
 LDA NOUNNO
 LBEQ BADINP
 CMPA #32 ROPE
 LBNE DMSG26
 JSR EQUOBJ
 LDA NOUNNO
 CMPA #32
 LBEQ DMSG23
 CMPA #78
 LBEQ DMSG15
 LDB #32
 JSR CHGOBJ
 JSR CKDRAW
 LDA ROOM
 CMPA #27
 BNE A@
 LDA #78 DANGLING ROPE
 CLRB
 JSR XCHGOB
A@ JMP REPLY

* FILL VERB PROC

VFILL EQU *
 JSR EQUOBJ
 LDA NOUNNO
 CMPA #24 CANTEEN
 BEQ A@
 CMPA #14 EMPTY BEAKER
 BEQ A@
 CMPA #15 BEAKER OF ACID
 LBNE BADINP
A@ JSR HAVOBJ
 LBEQ NOHAVE
 CMPA #15 BEAKER OF ACID
 LBEQ DMSG63
 JMP GET02

* WEAR VERB PROC

VWEAR EQU *
 LDA NOUNNO
 CMPA #8 SPACE SUIT
 LBNE BADINP
 LDA #9 WEARING SUIT
 JSR HAVOBJ
 LBNE DMSG14
 LDA #8 SPACE SUIT
 JSR HAVOBJ
 LBEQ NOHAVE
 LDB #9 WEARING SUIT
 JSR REPOBJ
 JMP REPLY

* POUR BEAKER/ACID

POUR01 EQU *
 LDA #15 BEAKER OF ACID
 JSR HAVOBJ
 BEQ A@
 LDB #14 EMPTY BEAKER
 JSR REPOBJ
 LDA #125 CLOSED PANEL
 JSR CKOBJ
 BEQ C@
 LDB #124 OPEN PANEL
 JSR CHGOBJ
 JSR CKDRAW
 JMP DMSG72
A@ LDA NOUNNO
 CMPA #102 ACID
 BEQ B@
 LDA #14 EMPTY BEAKER
 JSR HAVOBJ
 LBNE DMSG22
B@ JMP NOHAVE
C@ LDA ROOM
 CMPA #40
 BNE D@
 LDA #84 CLOSED GRATE
 JSR CKOBJ
 BEQ D@
 LDB #86
 JSR XCHGOB
 JSR CKDRAW
 LDA #76 GRATE ACROSS STREAM
 LDB #75
 JSR XCHGOB
D@ JMP REPLY

* SET VERB PROC

VSET EQU *
 LDX #NOUN
 LDB #4
A@ LDA ,X+
 CMPA #'0
 BLO D@
 CMPA #'9
 BHI D@
 DECB
 BNE A@
 LDA ROOM
 CMPA #17
 LBEQ DMSG55
 CMPA #1
 LBNE DMSG23
 LDX #SETTAB
B@ LDA ,X
 BEQ C@
 CMPA NOUNNO
 BEQ C@
 LEAX 2,X
 BRA B@
C@ LDA 1,X
 STA SETNXT
 LDD NOUN
 STD MSG46A
 LDD NOUN+2
 ORB #$80
 STD MSG46A+2
 JMP DMSG46
D@ JMP BADINP
*
SETTAB EQU *
 FCB 111,7
 FCB 110,8
 FCB 108,11
 FCB 109,24
 FCB 0,16 <== SHOULD BE TRAP

TOTRAP EQU *
 LDA #16
 JMP EXITRM

*******************************
* CHECK FOR DARK AREA RTN
* CALLED FROM VLOOK
*
* RETURN WITH ZERO IF DARK
*******************************

INDARK EQU *
 PSHS B,X,Y,U
 LDA ROOM
 CMPA #19
 BEQ A@
 CMPA #5
 BEQ B@
C@ LDA #1
D@ PULS B,X,Y,U,PC
A@ LDU #SCRBLK
 JSR SHOSCR
 LDX #$0B00
 STX ROWCOL
 LDX #GSCRN+288*10
 STX SCRTOP
 LDX #MSG71
 JSR DISPLY
 CLRA
 BRA D@
B@ TST LITESW
 BEQ A@
 BRA C@

*******************************
* ROUTINE PERFORMED FOR EACH
* ITEM OF A PUT ALL.  ROUTINE
* SHOULD SET "A" REG TO ZERO
* IF NOT ALLOWED TO PUT DOWN.
*
* INPUT: A=OBJECT PUTTING DOWN
*******************************

CHKPA EQU *
 CMPA #14 EMPTY BEAKER
 BEQ A@
 CMPA #15 ACID BEAKER
 BEQ A@
 CMPA #9 WEARING SUIT
 BNE B@
A@ CLRA
B@ RTS

*******************************
* ROUTINE PERFORMED FOR EACH
* ITEM OF A GET ALL.  ROUTINE
* SHOULD SET "A" REG TO ZERO
* IF NOT ALLOWED TO PICK UP.
*
* INPUT: A=OBJECT PICKING UP
*******************************

CHKGA EQU *
 TSTA
 RTS

*******************************
* ROUTINE PERFORMED AFTER EACH
* VALID MOVE
*******************************

ECHMOV EQU *
 PSHS D,X,Y,U
 LDX SCORE
 CMPX #25
 BNE A@
 LDA #20 MESSAGE
 JSR FNDOBJ
 BNE A@
 DI
 LDA ROOM
 PSHS A
 LDA #4
 STA ROOM
 LDA #20 MESSAGE
 JSR PUTNRM
 PULS A
 STA ROOM
 EI
 LDX #MSG42
 JSR DISPLY
A@ LDA ROOM
 CMPA #8
 BLO B@
 CMPA #22
 BHI B@
 LDA #9 WEARING SUIT
 JSR HAVOBJ
 BNE B@
 LDX #MSG73
 JSR DISPLY
 JMP ENDGAM
B@ LDA ROOM
 CMPA #18
 BEQ D@
 CMPA #8
 BLO C@
 CMPA #11
 BLO D@
C@ LDA #12 BLANKET W/ICE
 JSR HAVOBJ
 BEQ D@
 LDA RANDOM
 CMPA #60
 BHI D@
 LDX #MSG79
 JSR DISPLY
D@ TST CAPSW
 BEQ H@
 DEC CAPSW
 LDA CAPSW
 BEQ G@
 CMPA #2
 BHI H@
 BEQ E@
 LDX #MSG89
 BRA F@
E@ LDX #MSG90
F@ JSR DISPLY
 BRA H@
G@ BSR UNCONS
H@ TST SPIDSW
 BEQ I@
 DEC SPIDSW
 BNE I@
 LDA #28
 LDB #29
 JSR XCHGOB
I@ PULS D,X,Y,U,PC

* PROCESS UNCONSCIOUS

UNCONS EQU *
 LDA #3
 STA CAPSW
 JSR CLS
 DI
 LDA #54
 JSR SHOOVL
 LDD #$0B00
 STD ROWCOL
 LDD #GSCRN+288*10
 STD SCRTOP
 LDA ROOM
 PSHS A
 CLR ROOM
A@ LDX #MSG91
 JSR DISPLY
 LDX #MSG0
 JSR DISPLY
 JSR GETLIN
 LDD SCORE
 ADDD #1
 STD SCORE
 DEC CAPSW
 BNE A@
 PULS A
 STA ROOM
 LDD ROWCOL
 PSHS D
 JSR DRAWSC
 PULS D
 STD ROWCOL
 LDX #MSG92
 JSR DISPLY
 RTS

*******************************
*   IN ROOM ROUTINES
*******************************

* ON THE BRIDGE

INRM33 EQU *
 LDA #91
 CLRB
 JSR CHGOBJ
 JSR CLS
 JSR DRAWSC
 LDX #MSG84
 JSR DISPLY
 JMP ENDGAM

* IN ROOM WITH SPIDER

INRM35 EQU *
 PSHS A
 LDA #28
 JSR CKOBJ
 BEQ A@
 LDA RANDOM
 ANDA #$7F
 CMPA #15
 LBLO GET06A
A@ PULS A,PC

*******************************
*   ENTER ROOM ROUTINES
*******************************

ENTR07 EQU *
 LDA #30 LIVE PLANT
 JSR HAVOBJ
 BNE C@
 LDA #31 DEAD PLANT
 JSR HAVOBJ
 BNE A@
 LDX #MSG102
 BRA B@
A@ LDX #MSG103
B@ JSR DISPLY
 LDX #MSG104
 BRA D@
C@ LDX #MSG27
D@ JSR DISPLY
 JMP ENDGAM

ENTR26 EQU *
 PSHS A,X
 TST BRIDSW
 BEQ A@
 CLR BRIDSW
 LDX #MSG86
 JSR DISPLY
 LDA ROOM
 CMPA #32
 BNE A@
 LDA #28
 DI
 STA ROOM
 LDA #77 STONES IN LAVA
 JSR PUTNRM
 LDB #31
 STB ROOM
 JSR PUTNRM
 LDA #32
 STA ROOM
 EI
A@ PULS A,X,PC

* ENTER BRIDGE

ENTR33 EQU *
 PSHS A,X
 LDA OBJCNT
 CMPA #4
 BLO B@
A@ JMP INRM33
B@ LDA #8 SPACE SUIT
 JSR HAVOBJ
 BNE A@
 LDA #9 WEARING SUIT
 JSR HAVOBJ
 BNE A@
 LDX #MSG85
 JSR DISPLY
 PULS A,X,PC

* ENTER DISINTIGRATION ROOM

ENTR39 EQU *
 TST DOORSW
 BEQ A@
 LDX #MSG101
 JSR DISPLY
 JMP ENDGAM
A@ RTS

*******************************
*   EXIT ROOM ROUTINES
*******************************

* EXIT TELEPORTER ROOM

EXIT03 EQU *
 PSHS D
 CMPB #5
 BHI A@
 LDA #120
 CLRB
 JSR CHGOBJ
A@ PULS D,PC

* EXIT ON FROZEN PLANET

EXIT08 EQU *
 PSHS A
 CMPB #8
 BLO D@
 CMPB #10
 BHI D@
 LDA ROOM
 CMPA #3
 BEQ D@
 CMPA #18
 BEQ D@
 STB ROOM
 DI
 LDA #53 SPACE BACKGROUND
 JSR SHOOVL
 LDA #19 STAR IN SPACE
 JSR SHOOVL
 LDA #46 LEFT SIDE MOUNTAINS
 JSR SHOOVL
 LDA #17 RIGHT SIDE MOUNTAINS
 JSR SHOOVL
 INCA ICE AT BOTTOM
 JSR SHOOVL
 CALCX 60,1
 LDA #64
 STA 0,S
 LDA NOUNNO
 ANDA #1
 BNE B@
A@ CALCD 60,1,77,128
 JSR SCRRIT
 DEC 0,S
 BNE A@
 BRA C@
B@ CALCD 60,1,77,128
 JSR SCRLFT
 DEC 0,S
 BNE B@
C@ JSR CLSTXT
 JMP VLOOK2
D@ PULS A,PC

* EXIT ON DESERT PLANET

EXIT11 EQU *
 PSHS A
 CMPB #11
 BLO D@
 CMPB #14
 BHI D@
 LDA ROOM
 CMPA #3
 BEQ D@
 STB ROOM
 DI
 LDA #33 REMOVE OBJ WITH OVLS
E@ JSR SHOOVL
 INCA
 CMPA #38
 BLO E@
 CALCX 51,1
 LDA #64
 STA 0,S
 LDA NOUNNO
 ANDA #1
 BNE B@
A@ CALCD 51,1,82,128
 JSR SCRRIT
 DEC 0,S
 BNE A@
 BRA C@
B@ CALCD 51,1,82,128
 JSR SCRLFT
 DEC 0,S
 BNE B@
C@ JSR CLSTXT
 JMP VLOOK2
D@ PULS A,PC

* EXIT FROM BRIDGE

EXIT33 EQU *
 PSHS D
 INC BRIDSW
 LDA #91
 LDB #90
 JSR XCHGOB
 PULS D,PC

* EXITS FOR HANDLING SPIDER

EXIT35 EQU *
 PSHS A
 CMPB #41
 BEQ A@
 LDA #28
 JSR CKOBJ
 LBNE DMSG96
A@ PULS A,PC

EXIT38 EQU *
 PSHS D
 CMPB #40
 BNE A@
 LDA #29
 JSR FNDOBJ
 LBMI GET06A
 BEQ A@
 LDA #29
 CLRB
 JSR XCHGOB
 LDB #40
 STB ROOM
 LDA #28
 JSR PUTNRM
A@ PULS D,PC

EXIT40 EQU *
 PSHS A
 CMPB #28
 BNE A@
 JSR CKOBJ
 LBNE DMSG96
A@ PULS A,PC

*******************************
*  ANTIMATION ROUTINES
*******************************

* BLINK LIGHTS IN CONTROL ROOM

MOVLIT EQU *
 LDX FLIPCT
 LEAX 1,X
 STX FLIPCT
 CMPX #10
 BLO A@
 CLR FLIPCT
 CLR FLIPCT+1
 LDA RANDOM
 PSHS A
 ANDA #3
 STA COLOR1
 PULS A
 LSRA
 LSRA
 LSRA
 ANDA #3
 CMPA COLOR1
 BNE B@
 INCA
 ANDA #3
B@ STA COLOR2
 CALCX 50,33
 CALCD 50,33,54,92
 JSR FLPCLR
A@ RTS

* FLIP TELEPORT WINDOW

MOVWIN EQU *
 LDA #120 TELEPORT WINDOW
 JSR CKOBJ
 BEQ C@
 INC FLIPCT
 LDA FLIPCT
 CMPA #10
 BLO C@
 CLR FLIPCT
 LDA FLIPSW
 EORA #1
 STA FLIPSW
 BEQ A@
 LDA #14 TELEPORT WINDOW OVL
 BRA B@
A@ LDA #13 TELEPORT WINDOW OVL
B@ JSR SHOOVL
C@ RTS

* MOVE TELEPORT CONTROLS

MOVTEL EQU *
 CALCX 10,105
 CALCD 10,105,65,112
 JSR SCRUP
 CALCX 4,49
 CALCD 4,49,12,64
 JSR SCRRIT
 CALCX 4,65
 JSR SCRLFT
 INC FLP2SW
 LDA FLP2SW
 CMPA #12
 BLO MOVWIN
 CLR FLP2SW
 LDA #WHITE
 STA COLOR1
 LDA #RED
 STA COLOR2
 CALCX 42,61
 CALCD 42,61,43,72
 JSR FLPCLR
 LDA #BLUE
 STA COLOR2
 CALCX 8,49
 CALCD 8,49,8,80
 JSR FLPCLR
 BRA MOVWIN

* MOVE LIGHTS IN COMMUNICATIONS

MOVCOM EQU *
 INC FLIPSW
 LDA FLIPSW
 CMPA #20
 BLO A@
 CLR FLIPSW
 LDA #RED
 STA COLOR1
 LDA #BLUE
 STA COLOR2
 CALCX 34,85
 CALCD 34,85,36,96
 JSR FLPCLR
 CALCX 50,61
 LDA #100 ROBOT NO CART
 JSR CKOBJ
 BEQ B@
 CALCX 50,21
B@ CALCD 50,21,54,28
 JSR FLPCLR
A@ RTS

* MOVE LAVA FROM ON BRIDGE

MOVLV1 EQU *
 LDX FLIPCT
 LEAX 1,X
 STX FLIPCT
 CMPX #6
 BLO A@
 CLR FLIPCT
 CLR FLIPCT+1
 LDA #91 BRIDGE
 JSR CKOBJ
 BNE B@
 CALCD 32,1,54,128
 BRA C@
B@ CALCX 32,73
 CALCD 32,73,54,128
 JSR SCRLFT
 CALCD 32,1,54,48
C@ CALCX 32,1
 JSR SCRLFT
A@ RTS

* MOVE FORCE FIELD

MOVFOR EQU *
 LDX FLIPCT
 LEAX 1,X
 STX FLIPCT
 CMPX #8
 BLO C@
 CLR FLIPCT
 CLR FLIPCT+1
 LDA FLIPSW
 EORA #1
 STA FLIPSW
 BEQ A@
 LDA #127
 BRA B@
A@ LDA #148
B@ JSR SHOOVL
C@ RTS

* MOVE SPIDERS MOUTH

MOVSPI EQU *
 LDA #28 SPIDER
 JSR CKOBJ
 BEQ E@
 LDX FLIPCT
 LEAX 1,X
 STX FLIPCT
 CMPX #10
 BLO E@
 CLR FLIPCT
 CLR FLIPCT+1
 LDA FLIPSW
 BEQ A@
 DECA
 BEQ B@
 LDA #112
 CLR FLIPSW
 BRA D@
A@ LDA #108
 BRA C@
B@ LDA #111
C@ INC FLIPSW
D@ JSR SHOOVL
E@ RTS

* BLINK LIGHT OVER DOOR

MOVDOR EQU *
 TST DOORSW
 BEQ A@
 LDX FLIPCT
 LEAX 1,X
 STX FLIPCT
 CMPX #18
 BLO A@
 CLR FLIPCT
 CLR FLIPCT+1
 LDA #RED
 STA COLOR1
 LDA #BLACK
 STA COLOR2
 CALCX 38,65
 CALCD 38,65,39,68
 JSR FLPCLR
A@ RTS

* MOVE CLOUDS IN BOER CONTROL

MOVCLO EQU *
 LDX FLP2CT
 LEAX 1,X
 STX FLP2CT
 CMPX #18
 BLO A@
 CLR FLP2CT
 CLR FLP2CT+1
 CALCX 17,25
 CALCD 17,25,24,44
 JSR SCRRIT
A@ JMP MOVWIN

* MOVE LAVA IN CHASM

MOVLAV EQU *
 LDX FLIPCT
 LEAX 1,X
 STX FLIPCT
 CMPX #6
 BLO C@
 CLR FLIPCT
 CLR FLIPCT+1
 LDA #77 STONES
 JSR CKOBJ
 BEQ A@
 CALCX 71,1
 CALCD 71,1,80,40
 JSR SCRLFT
 CALCX 71,49
 CALCD 71,49,80,128
 BRA B@
A@ CALCX 71,1
 CALCD 71,1,80,128
B@ JSR SCRLFT
C@ RTS

*
* END OF FILE: ADVENT02/ASM
*
